/*
  Listing 1
  Magnetic Gear Clock Using Adruino UNO.
  Using Interrupt and PWM outputs.
  Three coils operated in sequence, wrap around style.
  Coil 1 fades off while coil 2 fades on.
  Coil 2 fades off while coil 3 fades on.
  Coil 3 fades off while coil 1 fades on.
  
  Half second pulses are received on pin 2 = Interrupt 0.
  A count from 1 to 6 is done on these pulses.
  At 2, 4, 6 fading from coil to coil occurs.
  Example provided without warranty.  Use at your own risk.
  */
  
////////////////////////////////////////////////////////////  
  
// Declare variables
int Coil1 = 9;    //Coil 1 connected to pin 9
int Coil2 = 10;    //Coil 2 connected to pin 10
int Coil3 = 11;    //Coil 3 connected to pin 11
volatile boolean C1 = false;  //Trigger for coil 1
volatile boolean C2 = false;  //Trigger for coil 2
volatile boolean C3 = false;  //Trigger for coil 3

int ticks = 0;  //Variable to count input pulses

////////////////////////////////////////////////////////////

void setup()  {
  //Declare coil pins as outputs, Interrupt 0 executes countticks.
  pinMode(Coil1, OUTPUT);
  pinMode(Coil2, OUTPUT);
  pinMode(Coil3, OUTPUT);
  attachInterrupt(0, countticks, RISING);
}

////////////////////////////////////////////////////////////
//Main Loop
void loop()  {
  
  if (C1 == true) {
  for(int fadevalue = 255 ;fadevalue >=0; fadevalue -=5) {
    analogWrite(Coil1, fadevalue);
    analogWrite(Coil2, 255 - fadevalue);
    delay(19);
    (C1 = false);
  }
  }
  if (C2 == true) {
  for(int fadevalue = 255 ;fadevalue >=0; fadevalue -=5) {
    analogWrite(Coil2, fadevalue);
    analogWrite(Coil3, 255 - fadevalue);
    delay(19);
    (C2 = false);
  }
  }
  if (C3 == true) {
  for(int fadevalue = 255 ;fadevalue >=0; fadevalue -=5) {
    analogWrite(Coil3, fadevalue);
    analogWrite(Coil1, 255 - fadevalue);
    delay(19);
  (C3 = false);  
  }
  }
}

void countticks()
{
  ticks = ticks + 1;
  if (ticks == 2)  { C1 = true; }
  if (ticks == 4)  { C2 = true; }
  if (ticks == 6)  { C3 = true; ticks = 0; }
}

  
